BN_rand(3)

NAME
BN_rand, BN_pseudo_rand - generate pseudo-random number

LIBRARY
libcrypto, -lcrypto

SYNOPSIS

 #include <openssl/bn.h>
 int BN_rand(BIGNUM *rnd, int bits, int top, int bottom);
 int BN_pseudo_rand(BIGNUM *rnd, int bits, int top, int bottom);

DESCRIPTION
BN_rand() generates a cryptographically strong pseudo-random number of bits bits in length and stores it in rnd. If top is true, the two most significant bits of the number will be set to 1, so that the product of two such random numbers will always have 2*bits length. If bottom is true, the number will be odd.

BN_pseudo_rand() does the same, but pseudo-random numbers generated by this function are not necessarily unpredictable. They can be used for non-cryptographic purposes and for certain purposes in cryptographic protocols, but usually not for key generation etc.

The PRNG must be seeded prior to calling BN_rand().

RETURN VALUES
BN_rand() and BN_pseudo_rand() return 1 on success, 0 on error. The error codes can be obtained by the ERR_get_error(3)|ERR_get_error(3) manpage.

SEE ALSO
the bn(3)|bn(3) manpage, the err(3)|err(3) manpage, the rand(3)|rand(3) manpage, the RAND_add(3)|RAND_add(3) manpage, the RAND_bytes(3)|RAND_bytes(3) manpage

HISTORY
BN_rand() is available in all versions of SSLeay and OpenSSL. BN_pseudo_rand() was added in OpenSSL 0.9.5.